Doomsday Engine - Bug #2268

Build Error - incorp assimp commit (PPC)
2018-01-24 04:20 - caseyac

Status: Closed Start date: 2018-01-24
Priority: Normal % Done: 100%
Assignee: skyjake

Category: 3rd party compatibility

Target version:

Description

assimp included with DE 2.0.0 to 2.1 causes a build fail on PowerPC (A-eon Cyrus Plus, based on Freescale P5020, running Ubuntu
16.04.3 LTS, gcc 5.3.1)

This issue was closed via assimp commit f0d03ec (
https://github.com/assimp/assimp/commit/f0d03ec6b8400cfde29bc460ad8dd69d6623be9c). Could you incorporate this into
Doomsday?

Build fail:

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp: In instanti
ation of ‘std::size_t Assimp::Copy(uint8_t*, T&) [with T = short unsigned int; std::size_t = unsig
ned int; uint8_t = unsigned char]’:

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:95:50: r
equired from here

/home/casey/Documents/Sources/doomsday—-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:87:27: e
rror: lvalue required as unary ‘&’ operand

std: :memcpy (data, &AI_BE(field), sizeof(field)); return sizeof (field);

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp: In inst
antiation of ‘std::size_t Assimp::Copy(uint8_t*, T&) [with T = unsigned int; std::size_t = unsigne
d int; uint8_t = unsigned char]’:

/home/casey/Documents/Sources/doomsday—-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:96:50: r
equired from here

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:87:27: e
rror: lvalue required as unary ‘&’ operand

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp: In inst
antiation of ‘std::size_t Assimp::Copy(uint8_t*, T&) [with T = int; std::size_t = unsigned int; ui
nt8_t = unsigned char]’:

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:110:48:
required from here

/home/casey/Documents/Sources/doomsday-2.0.0/doomsday/external/assimp/code/Bitmap.cpp:87:27: e
rror: lvalue required as unary ‘&’ operand

sdk/libgui/assimp/code/CMakeFiles/assimp.dir/build.make:518: recipe for target 'sdk/libgui/ass
imp/code/CMakeFiles/assimp.dir/Bitmap.cpp.o' failed

make[2]: * [sdk/libgui/assimp/code/CMakeFiles/assimp.dir/Bitmap.cpp.o] Error 1

CMakeFiles/Makefile2:592: recipe for target 'sdk/libgui/assimp/code/CMakeFiles/assimp.dir/all’
failed

make[1l]: [sdk/libgui/assimp/code/CMakeFiles/assimp.dir/all] Error 2

Makefile:151: recipe for target 'all' failed

make: ** [all] Error 2

History

#1 - 2018-01-24 12:29 - skyjake

- Category set to 3rd party compatibility

- Status changed from New to In Progress
- Assignee set to skyjake

- Target version set to 72

I'll check out the patch. If it can't be incorporated as-is, maybe the version of Assimp that Doomsday uses could be upgraded as a whole.
https://github.com/assimp/assimp/commit/f0d03ec6b8400cfde29bc460ad8dd69d6623be9c

#2 - 2018-01-24 22:27 - skyjake

I've now patched the Assimp used in both the stable and master branches of Doomsday. Could you give one or both of these a try and see if the
problem has been solved, please?

#3 - 2018-01-24 22:27 - skyjake
- % Done changed from 0 to 100

#4 - 2018-02-07 22:39 - caseyac

Sorry for the delay! | tried build 2586; unfortunately it was not successful.
Build fail:

[ 22%] Building CXX object sdk/libgui/assimp/code/CMakeFiles/assimp.dir/SIBImporter.cpp.o

<command-line>:0:0: warning: "DENG_LIBRARY_DIR" redefined

<command-line>:0:0: note: this is the location of the previous definition
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/SIBImporter.cpp:88:16: warning: ‘SIBPair
makePair(uint32_t, uint32_t)’ defined but not used [-Wunused-function]

static SIBPair makePair(uint32_t a, uint32_t b) { return (a<b) ? SIBPair(a, b)

A

[ 22%] Building CXX object sdk/libgui/assimp/code/CMakeFiles/assimp.dir/gITFImporter.cpp.o

<command-line>:0:0: warning: "DENG_LIBRARY_DIR" redefined

<command-line>:0:0: note: this is the location of the previous definition

In file included from /home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.h:65:0,
from /home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFImporter.cpp:55:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.inl: In member function ‘void
gITF::Asset::ReadBinaryHeader(Assimp::I0Stream&)’:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.inl:906:5: note: in expansion of macro
‘Al_SWAP#’

Al_SWAP4(header.version);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.inl:912:5: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.sceneFormat);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define Al_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.inl:917:5: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.length);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAsset.inl:918:5: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.scenelLength);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl: In member function ‘void
gITF::AssetWriter::WriteBinaryData(Assimp::I0Stream*, size_t)’:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:397:9: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.version);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:400:9: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.length);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define Al_SWAP4(p) ByteSwap::Swap4(&(p))

A
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:403:9: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.scenelLength);

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/ByteSwapper.h:217:24: error: ‘ByteSwap’ has not
been declared # define AI_SWAP4(p) ByteSwap::Swap4(&(p))

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:406:9: note: in expansion of macro
‘Al_SWAP4’

Al_SWAP4(header.sceneFormat);

A

In file included from /home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.h:87:0,

from /home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFImporter.cpp:57:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl: In instantiation of
‘rapidjson::Value& gITF::{anonymous}::MakeValue(rapidjson::Value&, float (&)[N], rapidjson::MemoryPoolAllocator<>&) [with unsigned int N = 4u;
rapidjson::Value = rapidjson::GenericValue<rapidjson::UTF8<> >]’:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:162:81:  required from here
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:59:31: warning: comparison
between signed and unsigned integer expressions [-Wsign-compare]

for (inti=0;i<N;++i) {

A

/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl: In instantiation of
‘rapidjson::Value& gITF::{anonymous}::MakeValue(rapidjson::Value&, float (&)[N], rapidjson::MemoryPoolAllocator<>&) [with unsigned int N = 16u;
rapidjson::Value = rapidjson::GenericValue<rapidjson::UTF8<> >]’:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:243:73:  required from here
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:59:31: warning: comparison
between signed and unsigned integer expressions [-Wsign-compare]
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl: In instantiation of
‘rapidjson::Value& gITF::{anonymous}::MakeValue(rapidjson::Value&, float (&)[N], rapidjson::MemoryPoolAllocator<>&) [with unsigned int N = 3u;
rapidjson::Value = rapidjson::GenericValue<rapidjson::UTF8<> >]’:
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:248:83:  required from here
/home/casey/Documents/Sources/doomsday-2.1.0-build2586/doomsday/external/assimp/code/gITFAssetWriter.inl:59:31: warning: comparison
between signed and unsigned integer expressions [-Wsign-compare]

sdk/libgui/assimp/code/CMakeFiles/assimp.dir/build.make:2270: recipe for target 'sdk/libgui/assimp/code/CMakeFiles/assimp.dir/gITFImporter.cpp.o'
failed

make?: * [sdk/libgui/assimp/code/CMakeFiles/assimp.dir/gITFImporter.cpp.o] Error 1

CMakeFiles/Makefile2:592: recipe for target 'sdk/libgui/assimp/code/CMakeFiles/assimp.dir/all’ failed

make': [sdk/libgui/assimp/code/CMakeFiles/assimp.dir/all] Error 2

Makefile:151: recipe for target 'all' failed

make: ** [all] Error 2

casey@UTOPIA-DEV:~/Documents/Sources/doomsday$

#5 - 2018-10-27 16:03 - skyjake
- Status changed from In Progress to Closed

- Target version deleted (72)

Perhaps this should be revisited when Doomsday's Assimp is upgraded to the latest stable version.
